# Interface methods for submodule: vnl_vector
from typing import Union, Any
# additional imports
from .support.template_class import itkTemplate as _itkTemplate



# Interface methods for class: vnl_vector
class vnl_vectorProxy():
	def size(self) -> int:
		""""""
		...

	@overload
	def put(self, i: int, v) -> None:
		""""""
		...

	@overload
	def put(self, i: int, v: float) -> None:
		""""""
		...

	@overload
	def put(self, i: int, v: int) -> None:
		""""""
		...

	@overload
	def get(self, i: int):
		""""""
		...

	@overload
	def get(self, i: int) -> float:
		""""""
		...

	@overload
	def get(self, i: int) -> int:
		""""""
		...

	@overload
	def fill(self, v) -> vnl_vector:
		""""""
		...

	@overload
	def fill(self, v: float) -> vnl_vector:
		""""""
		...

	@overload
	def fill(self, v: int) -> vnl_vector:
		""""""
		...

	def copy_in(self, ptr) -> vnl_vector:
		""""""
		...

	def copy_out(self, arg0) -> None:
		""""""
		...

	def set(self, ptr) -> vnl_vector:
		""""""
		...

	@overload
	def __call__(self, i: int):
		""""""
		...

	@overload
	def __call__(self, i: int) -> float:
		""""""
		...

	@overload
	def __call__(self, i: int) -> int:
		""""""
		...

	def pre_multiply(self, M: vnl_matrix) -> vnl_vector:
		""""""
		...

	def post_multiply(self, M: vnl_matrix) -> vnl_vector:
		""""""
		...

	def data_block(self):
		""""""
		...

	def begin(self):
		""""""
		...

	def end(self):
		""""""
		...

	@overload
	def front(self):
		""""""
		...

	@overload
	def front(self) -> float:
		""""""
		...

	@overload
	def front(self) -> int:
		""""""
		...

	@overload
	def back(self):
		""""""
		...

	@overload
	def back(self) -> float:
		""""""
		...

	@overload
	def back(self) -> int:
		""""""
		...

	def extract(self, len: int, start: int = 0) -> vnl_vector:
		""""""
		...

	def update(self, arg0: vnl_vector, start: int = 0) -> vnl_vector:
		""""""
		...

	@overload
	def squared_magnitude(self) -> float:
		""""""
		...

	@overload
	def squared_magnitude(self) -> int:
		""""""
		...

	@overload
	def magnitude(self) -> float:
		""""""
		...

	@overload
	def magnitude(self) -> int:
		""""""
		...

	@overload
	def one_norm(self) -> float:
		""""""
		...

	@overload
	def one_norm(self) -> int:
		""""""
		...

	@overload
	def two_norm(self) -> float:
		""""""
		...

	@overload
	def two_norm(self) -> int:
		""""""
		...

	@overload
	def inf_norm(self) -> float:
		""""""
		...

	@overload
	def inf_norm(self) -> int:
		""""""
		...

	def normalize(self) -> vnl_vector:
		""""""
		...

	@overload
	def rms(self) -> float:
		""""""
		...

	@overload
	def rms(self) -> int:
		""""""
		...

	@overload
	def min_value(self):
		""""""
		...

	@overload
	def min_value(self) -> float:
		""""""
		...

	@overload
	def min_value(self) -> int:
		""""""
		...

	@overload
	def max_value(self):
		""""""
		...

	@overload
	def max_value(self) -> float:
		""""""
		...

	@overload
	def max_value(self) -> int:
		""""""
		...

	def arg_min(self) -> int:
		""""""
		...

	def arg_max(self) -> int:
		""""""
		...

	@overload
	def mean(self):
		""""""
		...

	@overload
	def mean(self) -> float:
		""""""
		...

	@overload
	def mean(self) -> int:
		""""""
		...

	@overload
	def sum(self):
		""""""
		...

	@overload
	def sum(self) -> float:
		""""""
		...

	@overload
	def sum(self) -> int:
		""""""
		...

	@overload
	def flip(self) -> vnl_vector:
		""""""
		...

	@overload
	def flip(self, b: int, e: int) -> vnl_vector:
		""""""
		...

	def roll(self, shift: int) -> vnl_vector:
		""""""
		...

	def roll_inplace(self, shift: int) -> vnl_vector:
		""""""
		...

	def swap(self, that: vnl_vector) -> None:
		""""""
		...

	def assert_size(self, arg0: int) -> None:
		""""""
		...

	def assert_finite(self) -> None:
		""""""
		...

	def is_finite(self) -> bool:
		""""""
		...

	def is_zero(self) -> bool:
		""""""
		...

	def empty(self) -> bool:
		""""""
		...

	def is_equal(self, rhs: vnl_vector, tol: float) -> bool:
		""""""
		...

	def operator_eq(self, v: vnl_vector) -> bool:
		""""""
		...

	def set_size(self, n: int) -> bool:
		""""""
		...

	def clear(self) -> None:
		""""""
		...

	def read_ascii(self, s) -> bool:
		""""""
		...

	@staticmethod
	def read(s) -> vnl_vector:
		""""""
		...

	def set_data(self, datain, sz: int, LetArrayManageMemory: bool) -> None:
		""""""
		...

	def set_data_same_size(self, datain, LetArrayManageMemory: bool) -> None:
		""""""
		...

